unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Grids, StdCtrls, Types;

type
  { TForm1 }

  TForm1 = class(TForm)
    BtnNew: TButton;
    BtnEdit: TButton;
    BtnDelete: TButton;
    DrawGrid1: TDrawGrid;
    procedure BtnDeleteClick(Sender: TObject);
    procedure BtnEditClick(Sender: TObject);
    procedure BtnNewClick(Sender: TObject);
    procedure DrawGrid1DrawCell(Sender: TObject; aCol, aRow: Integer;
      aRect: TRect; aState: TGridDrawState);
    procedure FormCreate(Sender: TObject);
  private

  protected
    function GetArtikelIndex: Integer;
    function GetCellText(ACol, ARow: Integer): String;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  Unit2, Unit3;

{ TForm1 }

procedure TForm1.BtnNewClick(Sender: TObject);
var
  F: TArtikelPreisEditor;
  A: TArtikelPreis;
  idx: Integer;
begin
  F := TArtikelPreisEditor.Create(nil);
  try
    F.Position := poMainFormCenter;
    F.Init;
    if F.ShowModal = mrOK then begin
      A := TArtikelPreis.Create;
      F.GetArtikel(A);
      idx := ArtikelPreisListe.Add(A);
      DrawGrid1.RowCount := DrawGrid1.FixedRows + ArtikelPreisListe.Count;
      DrawGrid1.Invalidate;
    end;
  finally
    F.Free;
  end;
end;

procedure TForm1.DrawGrid1DrawCell(Sender: TObject; aCol, aRow: Integer;
  aRect: TRect; aState: TGridDrawState);
var
  txt: String;
begin
  txt := GetCellText(ACol, ARow);
  {
  DrawGrid1.Canvas.Font.Assign(DrawGrid1.Font;
  if AState * [gdFocused, gdSelected] <> [] then begin
    DrawGrid1.Canvas.Font.Color := clGrayText;
    DrawGrid1.Canvas.Brush.Color := clForm;
  end else begin
    DrawGrid1.Canvas.Brush.Color := clWindow;
    DrawGrid1.Canvas.Font.Color := clWindowText;
  end;
  }
  DrawGrid1.Canvas.FillRect(ARect);
  DrawGrid1.Canvas.TextRect(ARect, ARect.Left+constCellPadding, ARect.Top+constCellPadding, txt);
end;

function TForm1.GetCellText(ACol, ARow: Integer): String;
var
  A: TArtikelPreis;
begin
  if ARow = 0 then begin
    case ACol of
      0: Result := '';
      1: Result := 'Name';
      2: Result := 'Preis';
      3: Result := 'Mengeneinh.';
      4: Result := 'MwSt';
    end;
  end else
  if ArtikelPreisListe.Count > 0 then begin
    A := ArtikelPreisListe[ARow - DrawGrid1.FixedRows];
    if A = nil then
      Result := ''
    else
    case ACol of
      0: Result := IntToStr(ARow);
      1: result := A.Name;
      2: Result := FormatCurr('0.00 €', A.Preis);
      3: Result := IntToStr(A.MengenEinheit);
      4: Result := FormatFloat('0.0%', A.MwSt);
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DrawGrid1.Colcount := DrawGrid1.FixedCols + 4;
end;

procedure TForm1.BtnEditClick(Sender: TObject);
var
  F: TArtikelPreisEditor;
  A: TArtikelPreis;
  idx: Integer;
begin
  idx := GetArtikelIndex;
  if idx < 0 then
    exit;
  A := ArtikelPreisListe[idx];
  F := TArtikelPreiseditor.Create(nil);
  try
    F.Position := poMainFormCenter;
    F.SetArtikel(A);
    if F.ShowModal = mrOK then begin
      F.GetArtikel(A);
      DrawGrid1.Invalidate;
    end;
  finally
    F.Free;
  end;
end;

procedure TForm1.BtnDeleteClick(Sender: TObject);
var
  idx: Integer;
begin
  idx := GetArtikelIndex;
  if idx < 0 then exit;
  if MessageDlg('Wollen Sie diesen Artikel wirklich löschen?', mtConfirmation,
    [mbYes, mbNo], 0) = mrYes
  then begin
    ArtikelPreisListe.Delete(idx);
    DrawGrid1.RowCount := DrawGrid1.RowCount-1;
    if idx >= ArtikelPreisListe.Count then idx := ArtikelPreisListe.Count-1;
    DrawGrid1.Row := DrawGrid1.FixedRows + idx;
    Drawgrid1.Invalidate;
  end;
end;


function TForm1.GetArtikelIndex: Integer;
begin
  Result := DrawGrid1.Row - DrawGrid1.FixedRows;
end;


end.

