unit Unit2;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ButtonPanel,
  Unit3;

type

  { TArtikelPreisEditor }

  TArtikelPreisEditor = class(TForm)
    ButtonPanel1: TButtonPanel;
    EdPreis: TEdit;
    EdMwSt: TEdit;
    EdMengenEinheit: TEdit;
    EdName: TEdit;
    Label1: TLabel;
    LblPreis: TLabel;
    Label2: TLabel;
    LblMwSt: TLabel;
    procedure OKButtonClick(Sender: TObject);
  private
    function ValidData(out AMsg: String; out AControl: TWinControl): Boolean;

  public
    procedure Init;
    procedure GetArtikel(Artikel: TArtikelPreis);
    procedure SetArtikel(Artikel: TArtikelPreis);

  end;

var
  ArtikelPreisEditor: TArtikelPreisEditor;

implementation

{$R *.lfm}

procedure TArtikelPreisEditor.OKButtonClick(Sender: TObject);
var
  msg: String;
  C: TWinControl;
begin
  if not ValidData(msg, C) then begin
    C.SetFocus;
    MessageDlg(msg, mtError, [mbOK], 0);
    ModalResult := mrNone;
  end;
end;

procedure TArtikelPreisEditor.Init;
begin
  EdName.Text := '';
  EdPreis.Text := '';
  EdMengenEinheit.Text := '1';
  EdMwSt.Text := '19';
end;

procedure TArtikelPreisEditor.GetArtikel(Artikel: TArtikelPreis);
begin
  if Artikel <> nil then
  begin
    Artikel.Name := EdName.Text;
    Artikel.Preis := StrToCurr(EdPreis.Text);
    Artikel.MengenEinheit := StrToInt(EdMengenEinheit.Text);
    Artikel.MwSt := StrToFloat(EdMwSt.Text);
  end;
end;

procedure TArtikelPreisEditor.SetArtikel(Artikel: TArtikelPreis);
begin
  if Artikel <> nil then
  begin
    EdName.Text := Artikel.Name;
    EdPreis.Text := CurrToStr(Artikel.Preis);
    EdMengenEinheit.Text := IntToStr(Artikel.MengenEinheit);
    EdMwSt.Text := FloatToStr(Artikel.MwSt);
  end;
end;

function TArtikelPreisEditor.ValidData(out AMsg: String;
  out AControl: TWinControl): Boolean;
var
  C: Currency;
  I: Integer;
  F: Double;
begin
  Result := false;
  if EdName.Text = '' then begin
    AMsg := 'Eingabe für Artikel-Namen erforderlich.';
    AControl := EdName;
    exit;
  end;
  if EdPreis.Text = '' then begin
    AMsg :='Eingabe für Artikel-Preis erforderlich.';
    AControl := EdPreis;
    exit;
  end;
  if not TryStrToCurr(EdPreis.Text, C) then begin
    AMsg := 'Ungültige Preisangabe';
    AControl := EdPreis;
    exit;
  end;
  if EdMengenEinheit.text = '' then begin
    AMsg := 'Eingabe für Mengeneinheit erforderlich.';
    Acontrol := EdMengenEinheit;
    exit;
  end;
  if not TryStrToInt(EdMengenEinheit.Text, I) or (I <= 0) then begin
    AMsg := 'Ungültige Angabe für Mengeneinheit';
    AControl := EdMengenEinheit;
    exit;
  end;
  if EdMwSt.Text = '' then begin
    AMsg := 'Eingabe für Mehrwertsteuer erforderlich.';
    AControl := EdMwSt;
    exit;
  end;
  if not TryStrToFloat(EdMwSt.text, F) or (F < 0) then begin
    AMsg := 'Ungültige Eingabe für Mehrwertsteuer';
    Acontrol := EdMwSt;
    exit;
  end;
  Result := true;
end;




end.

