unit Unit3;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Contnrs;

type
  TArtikelPreis = class
    Name: String;
    Preis: Currency;
    Mengeneinheit: Integer;
    MWSt: Double;
    procedure CopyFrom(AValue: TArtikelPreis);
  end;

  TArtikelPreisListe = class(TObjectList)
  private
    function GetItem(AIndex: Integer): TArtikelPreis;
    procedure SetItem(AIndex: Integer; const AValue: TArtikelPreis);
  public
    property Items[AIndex: Integer]: TArtikelPreis read GetItem write SetItem; default;
  end;

var
  ArtikelPreisListe: TArtikelPreisListe;

implementation

procedure TArtikelPreis.CopyFrom(AValue: TArtikelPreis);
begin
  if AValue <> nil then begin
    Name := AValue.Name;
    Preis := AValue.Preis;
    MengenEinheit := AValue.MengenEinheit;
    MwSt := AValue.MwSt;
  end;
end;

function TArtikelPreisListe.GetItem(AIndex: Integer): TArtikelPreis;
begin
  Result := TArtikelPreis(inherited Items[AIndex]);
end;

procedure TArtikelPreisListe.SetItem(AIndex: Integer; const AValue: TArtikelPreis);
begin
  TArtikelPreis(inherited Items[AIndex]).CopyFrom(AValue);
end;

initialization
  ArtikelPreisListe := TArtikelPreisListe.Create;

finalization
  ArtikelPreisListe.Free;

end.

